/*
 dxf(ver2013)ファイルからデータを抽出する
   LAYER,SYTLE,LINE,LWPOLYLINE,CIRCLE(円・円弧),TEXT,MTEXT,POINT,ELLIPSE

   プログラムの作成にあたって
   素人が下手の横好きで動作優先のプログラムを作成していますので、きれいな文法になっていないかもしれません。
 　なおかつ名称も違うかもしれませんが、ご勘弁ください。
   
    "//"のあとが注釈ですが、簡単に記載していますのでご容赦ください。

*/

// JREシステムライブラリー
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
// 外部ライブラリー：SWT
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

public class DxfExtraction_seres_2013 extends SelectionAdapter {
	// 種々の定義
		private Display display ;
		private Text field [] = new Text [20] ;
		private Button [] button = new Button [20] ;
		private int noca , entino , norep , nores , objeno ;
		private String filem , line , msg ;
		static int irno , lastno ;
		static String nlayer , sensyu ,pathn ;
		static String []file1 =new String [10] ;

								// 抽出する項目
		private String [] koumk = {"1_線分","2_ポリライン","3_円","4_テキスト","5_マルチテキスト","6_点","7_楕円"} ;
								// 抽出する項目のテーブル項目
		private String [] kubet = {"LINE","LWPOLYLINE","CIRCLE","TEXT","MTEXT","POINT","ELLIPSE","ARC"} ;
//								    1234   1234567890   123456   1234   12345   12345   1234567   123
								// テーブル項目の文字数
		private int [] nkubet = {4,10,6,4,5,5,7,3} ;
								// ファイル分割等のキー文字
		private String [] secti = {"ENTITIES","AcDbLayerTableRecord","AcDbEntity","TABLES","ENDSEC","AcDbTextStyleTableRecord","OBJECTS"} ;
//								    12345678   12345678901234567890   1234567890   123456   123456   123456789012345678901234   1234567
								// キー文字の文字数
		private int [] nsecti = {8,20,10,6,6,24,7} ;
								// LAYERのグループコード
		private String [] grcodeY = {"  2"," 62","  6","290","370"} ;
								// SYTLEのグループコード
		private String [] grcodeS = {"  2"," 40"," 41"," 50"," 42","  3","  4","1000","1071"} ;
								// 線分LINEのグループコード
		private String [] grcodeL = {"  8","  6"," 62","370"," 10"," 20"," 30"," 11"," 21","31"} ;
								// ポリラインLWPOLYLINEのグループコード
		private String [] grcodeP = {"  8","  6"," 62","370"," 90"," 70"," 10"," 20"} ;
								// 円・円弧CIRCLEのグループコード
		private String [] grcodeC = {"  8","  6"," 62","370"," 10"," 20"," 30"," 40"," 50"," 51"} ;
								// 楕円ELLIPSEのグループコード
		private String [] grcodeEl= {"  8","  6"," 62","370"," 10"," 20"," 30"," 11"," 21"," 31"," 40"," 41"," 42"} ;
								// 点POINT
		private String [] grcodePO= {"  8","  6"," 62","370"," 10"," 20"," 30"} ;
								// テキストTEXTのグループコード
		private String [] grcodeT = {"  8","  6"," 62","370"," 10"," 20"," 30"," 40","  1"," 50"," 41"," 51","  7"," 72"," 11"," 21"," 31"," 73"} ;
								// マルチテキストMTEXTのグループコード
		private String [] grcodeM = {"  8","  6"," 62","370"," 10"," 20"," 30"," 40"," 50"," 41"," 46"," 71"," 72","  1","  7"," 11"," 21"," 31"," 73"," 44"} ;

		private String [] line1 = new String [10000000] ;	// 読み込み行データ
		private String [] nalayer = new String [500] ;		// LAYERの名称
		private String [] selayer = new String [500] ;		// LAYERの線種
		private int [] irnola = new int [500] ;				// LAYERの色番号
		private int [] printy = new int [500] ;				// LAYERの線の印刷有無
		private int [] futosa = new int [500] ;				// LAYERの線太さ

		private String [] s2 = new String [20] ;			// 文字スタイル
		private String [] s3 = new String [20] ;			// 1バイトコードのフォント名
		private String [] s4 = new String [20] ;			// 2バイトコードのSHXフォント名
		private String [] s1000 = new String [20] ;			// TrueTypeフォント
		private int [] i1071 = new int [20] ;				// フラグ

		private String [] nalayer0 = new String [100000] ;	// ENTITIESのLAYER名称(個々)
		private String [] selayer0 = new String [100000] ;	// ENTITIESの線種(個々)
		private int [] irnola0 = new int [100000] ;			// ENTITIESの色番号(個々)

		private int [] pkous = new int [50000] ;			// ポリラインの頂点数
		private int [] tojik = new int [50000] ;			// ポリラインの終端処理(閉じる閉じない)
		private double [] x1 = new double [50000] ;			// 始点ｘ
		private double [] y1 = new double [50000] ;			// 始点ｙ
		private double [] z1 = new double [50000] ;			// 始点ｚ
		private double [] x2 = new double [50000] ;			// 終点ｘ
		private double [] y2 = new double [50000] ;			// 終点ｙ
		private double [] z2 = new double [50000] ;			// 終点ｚ
		private double [][] x3 = new double [1000][250] ;	// ポリラインの頂点ｘ
		private double [][] y3 = new double [1000][250] ;	// ポリラインの頂点ｙ

		private String [] s1 = new String [100000] ;		// 文字列
		private String [] s7 = new String [100000] ;		// 文字スタイル

		private double [] d40 = new double [100000] ;		// 文字の高さ
		private double [] d41 = new double [100000] ;		// 参照矩形の幅
		private double [] d42 = new double [100000] ;		// 終点角度
		private double [] d44 = new double [100000] ;		// マルチテキスト行間隔係数
		private double [] d46 = new double [100000] ;		// ブロックの回転角度

		private double [] d50 = new double [100000] ;		// 文字の回転角度
		private double [] d51 = new double [100000] ;		// 文字の傾斜角度

		private int [] i370 = new int [100000] ;			// 線太さ
		private int [] i71 = new int [100000] ;				// マルチテキスト アタッチされる点
		private int [] i72 = new int [100000] ;				// 水平方向の文字位置合わせ
		private int [] i73 = new int [100000] ;				// 垂直位置合わせ

		private String ccc="null" ;

	public static void main( String[] args ) {				// main
		new DxfExtraction_seres_2013();
	}

	// 入力画面の設定
	DxfExtraction_seres_2013() {
			int hstart = 5 ;
			int hy0 = 20 ;	// 行高さ
			int hy1 = 5 ;	// 行間
			int []he = new int [40] ;
		for(int i = 0 ; i < 40 ; i++) {
			if (i==0) {
				he[i] = hstart ;
			} else {
				he[i] = he[i-1] + hy0 + hy1 ;
			}
		}

		// タイトル
			display = new Display();
			Shell shell = new Shell(display);
			shell.setText("dxfファイルからデータ抽出");

		// ボタンとフィールドの設定
			button[0] = new Button(shell, SWT.PUSH );
			button[0].setText("ファイル選択");
			button[0].setBounds(10, he[0], 100, hy0);
			button[0].addSelectionListener(this);
			field[0] = new Text(shell, SWT.MULTI | SWT.BORDER | SWT.WRAP);
			field[0].setTextLimit(200);
			field[0].setBounds(20, he[1], 460, 65);

			button[1] = new Button(shell, SWT.PUSH);
			button[1].setText("終　了");
			button[1].setBounds(390, he[3]+25, 70, hy0);
			button[1].addSelectionListener(this);

			shell.setBounds(0,0,500,170);	// 画面の大きさ
			shell.open();
		while(!shell.isDisposed()){
			if (!display.readAndDispatch()){
				display.sleep();
			}
		}
	}

	// buttonの動作の定義
	public void widgetSelected(SelectionEvent e) {
		// button[0]の動作
		if (e.getSource() == button[0]){				// button[0]が押されたら
			Shell shell2 = new Shell(display);
			FileDialog dialog = new FileDialog(shell2,SWT.OPEN);
			filem = dialog.open();					// 抽出するファイル名の取得
			pathn = dialog.getFilterPath()+"\\" ;	// そのフォルダ名の取得

			file1[0]=pathn+"z0_前半1.txt" ;			// 描画の際に必要なファイルの名称を定義
			file1[1]=pathn+"z1_前半2.txt" ;
			file1[2]=pathn+"z2_中間.txt" ;
			file1[3]=pathn+"z3_後半.txt" ;
			file1[4]=pathn+"z4_ラストno.txt" ;
			file1[8]=pathn+"z8_data.txt" ;

			field[0].setText(filem);				// ファイル名をフィールドに表示
			shell2.dispose() ;
			
			int ver=fileRead0(filem) ;				// 抽出ファイルの $ACADVER の取得
				String mjk0="SJIS" ;				// 抽出ファイルの文字コードの設定
			if (ver>1018) {
				mjk0="UTF-8" ;
			}
//			System.out.println(mjk0) ;
			fileRead(filem,mjk0) ;					// 抽出ファイルの全行データを 変数line1 に代入する

				int ltno1=0 , ltno2=0 ;
			for(int l = 0 ; l < noca-2 ; l++) {
				if (line1[l].length()==3 && line1[l].substring(0,3).equals("  5")) {	// グループコード「  5」を探す(3文字でしかも3文字が"  5"の行)
						ltno1 = Integer.parseInt(line1[l+1], 16);	// 次の行の値を16進数から10進数に変換
						lastno=Math.max(ltno1,ltno2) ;				// 抽出ファイルのハンドル番号の最大値の抽出
						ltno2=lastno ;
				}
			}
//			System.out.printf("200 %d%n",lastno) ;

			// 描画の際に必要なファイルを分割する
				fileExtract() ;

			// 	各項目のデータの抽出
				layerExtraction() ;
				styleExtraction() ;
				memor() ;	AcDbLine() ;
				memor() ;	AcDbPolyline() ;
				memor() ;	AcDbCircle() ;
				memor() ;	AcDbText() ;
				memor() ;	AcDbMText() ;
				memor() ;	AcDbPoint() ;
				memor() ;	AcDbEllipse() ;
		}

		// button[1]の動作
		if (e.getSource() == button[1]){
			menuFileExit();					// 終了する
		}
	}

	// 終了の設定
	public void menuFileExit() {
		System.exit(0);
	}

	// $ACADVER の取得
	public int fileRead0(String str) {											//　int(整数)を戻り値に定義
				int ver=0 ;														// 戻り値の変数(AC1027のうちの1027とか)
		// データの取り込み
		try {
				FileInputStream fis = new FileInputStream(str);					// 読み込みファイルの定義
				InputStreamReader in = new InputStreamReader(fis,"UTF-8");		// 読み込み時の文字コードの定義
				BufferedReader br = new BufferedReader(in);						// 1行単位の読み込みを定義
				for(int i = 0 ; i < 10 ; i++) { 
						msg = br.readLine() ;									// msgに１行文字列を代入する
					if (msg.equals("  1")) {									// グループコード「  1」を探す
						msg = br.readLine() ;									// msgに１行文字列を代入する msg=AC1027
						ver = (int) Float.parseFloat(msg.substring( 2, 6) ) ;	// AC1027の数字部を取り出し、整数でverに代入する
//						System.out.println(ver) ;
						break ;													// 終了
					}
				}

				br.close(); 													// ファイルのクローズ
		// エラーがあった場合
		} catch(FileNotFoundException e) {
		System.out.println("ファイルがありません");
		} catch(IOException e) {
			System.out.println("入出力エラーです");
		}
				return ver ;													// 戻る
	}

	// 抽出ファイルの全行データを 変数line1 に代入する
	public void fileRead(String str, String mjkd) {								// void：実施しても戻り値はない( クラス変数 line1 に代入したので)
		// データの取り込み
		try {
				FileInputStream fis = new FileInputStream(str);					// 読み込みファイルの定義
				InputStreamReader in = new InputStreamReader(fis,mjkd);			// 読み込み時の文字コードの定義
				BufferedReader br = new BufferedReader(in);						// 1行単位の読み込みを定義
						noca=-1 ;
			while ( ( line = br.readLine()) != null ) {							// line に１行文字列を代入する(ファイルの末まで実行する)
						noca=noca+1 ;											// 行をカウントする
						line1[noca] = line ;									// クラス変数 line1 に line を代入する
			}
				br.close();														// ファイルのクローズ
		// エラーがあった場合
		} catch(FileNotFoundException e) {
			System.out.println("ファイルがありません");
		} catch(IOException e) {
			System.out.println("入出力エラーです");
		}
					noca=noca+1 ;
	}

	// 描画の際に必要なファイルを分割する
	public void fileExtract() {
		// データの書き出し
		try {
			int i=0 ; int lsta=0 ; int lend=0 ;									// z0_前半1.txt
				FileOutputStream fos = new FileOutputStream(file1[i]);			// 書き込みファイルの定義
				OutputStreamWriter out = new OutputStreamWriter(fos,"SJIS");	// 書き込み時の文字コードの定義
				PrintWriter pw = new PrintWriter(out);							// 1行単位の書き込みを定義

				for(int l = 0 ; l < noca ; l++) {
					if (line1[l].equals("$HANDSEED")) {							// $HANDSEED を探す
						lend=l+2 ;												// z0_前半1.txt の終了行
						lsta=l+3 ;												// z1_前半2.txt の開始行
						break ;
					}
				}

				for(int l = 0 ; l < lend ; l++) {
					pw.printf("%s%n",line1[l]) ;								// z0_前半1.txt の書き込み
				}
				pw.close(); 													// ファイルのクローズ

			i=1 ;																// z1_前半2.txt
				fos = new FileOutputStream(file1[i]);							// 書き込みファイルの定義
				out = new OutputStreamWriter(fos,"SJIS");						// 書き込み時の文字コードの定義
				pw = new PrintWriter(out);										// 1行単位の書き込みを定義

				int ltno1=0 , ltno2=0 , ltno3=0, ltno4=0 ;
			for(int l = lsta ; l < noca ; l++) {
					if (line1[l].length()==5 && (line1[l].substring(0,5)).equals("LAYER")) {	// LAYER を探す(5文字でしかも5文字が"LAYER"の行)
						if (ltno1==0) {
							ltno1=l-4 ; 										// LAYER　 の開始行
//							System.out.printf("%d %s%n",ltno1,line1[ltno1]) ;
						}

						do {
									l++;
							if (line1[l].length()==3) {
									msg = line1[l].substring(0,3) ;
									ltno2=l+1 ; 								// LAYER　 の終了行
							}
						} while (!msg.equals("  0")) ;							// "  0"の行が LAYERデータの終端なので、その行まで代入する
					}
			}

//			System.out.printf("%d %s%n",ltno2,line1[ltno2]) ;
			
			for(int l = lsta ; l < noca ; l++) {
					if (line1[l].length()==5 && (line1[l].substring(0,5)).equals("STYLE")) {	// STYLE を探す
						if (ltno3==0) {
							ltno3=l-4 ; 										// STYLE　 の開始行
//							System.out.printf("%d %s%n",ltno3,line1[ltno3]) ;
						}

						do {
									l++;
							if (line1[l].length()==3) {
									msg = line1[l].substring(0,3) ;
									ltno4=l+1 ; 								// STYLE　 の終了行
							}
						} while (!msg.equals("  0")) ;							// "  0"の行が STYLEデータの終端なので、その行まで代入する
					}
			}
//			System.out.printf("%d %s%n",ltno4,line1[ltno4]) ;

				int stno1=Math.min(ltno1,ltno3) ;
				int stno2=Math.min(ltno2,ltno4) ;
				int stno3=Math.max(ltno1,ltno3) ;
				int stno4=Math.max(ltno2,ltno4) ;

				for(int l = lsta ; l < stno1+1 ; l++) {
					pw.printf("%s%n",line1[l]) ;								// z1_前半2.txt の書き込み
				}
				pw.close(); 													// ファイルのクローズ

			i=2 ;																// z2_中間.txt
				fos = new FileOutputStream(file1[i]);							// 書き込みファイルの定義
				out = new OutputStreamWriter(fos,"SJIS");						// 書き込み時の文字コードの定義
				pw = new PrintWriter(out);										// 1行単位の書き込みを定義

				if (stno2!=stno3) {
					for(int l = stno2+1 ; l < stno3-1 ; l++) {
							pw.printf("%s%n",line1[l]) ;						// z2_中間.txt の書き込み
					}
				}

				for(int l = stno4-1 ; l < noca ; l++) {
						pw.printf("%s%n",line1[l]) ;							// z2_中間.txt の書き込み
					if (line1[l].equals("ENTITIES")) {							// ENTITIES を探す
						lsta=l+1 ;
						break ;
					}
				}

				pw.close(); 													// ファイルのクローズ

			i=3 ;																// z3_後半.txt
				fos = new FileOutputStream(file1[i]);							// 書き込みファイルの定義
				out = new OutputStreamWriter(fos,"SJIS");						// 書き込み時の文字コードの定義
				pw = new PrintWriter(out);										// 1行単位の書き込みを定義

				for(int l = lsta ; l < noca ; l++) {
					if (line1[l].equals("ENDSEC")) {							// ENDSEC を探す
						lsta=l-1 ;
						break ;
					}
				}
				for(int l = lsta ; l < noca ; l++) {
						pw.printf("%s%n",line1[l]) ;							// z3_後半.txt の書き込み
				}
				pw.close(); 													// ファイルのクローズ

			i=4 ;																// z8_data.txt
				fos = new FileOutputStream(file1[i]);							// 書き込みファイルの定義
				out = new OutputStreamWriter(fos,"SJIS");						// 書き込み時の文字コードの定義
				pw = new PrintWriter(out);										// 1行単位の書き込みを定義

						pw.printf("%d%n",lastno) ;								// ハンドル番号の最大値の書き込み

				pw.close(); 													// ファイルのクローズ

			// エラーがあった場合
		} catch(FileNotFoundException e) {
			System.out.println("ファイルがありません");
		} catch(IOException e) {
			System.out.println("入出力エラーです");
		}
	}

	// LAYERデータの書き込み
	public void layerExtraction() {
		// レイヤー諸元の抽出
		try {
			FileOutputStream fos = new FileOutputStream(pathn+"0_レイヤー.csv");	// 書き込みファイルの定義
			OutputStreamWriter out = new OutputStreamWriter(fos,"SJIS");		// 書き込み時の文字コードの定義
			PrintWriter pw = new PrintWriter(out);								// 1行単位の書き込みを定義
						int nore = -1 ;
				pw.printf("%s,%s,%s,%s,%s,%s%n","No","レーヤー名","色番号","線種名","線太さ","印刷有無") ;	// データ名
				pw.printf("%s,%d,%d,%d,%d,%d%n","G-code",       2,      62,6       ,370     ,290) ;	// グループコード

				int ltno1=0 , ltno2=0 ;
			for(int i = 0 ; i < noca ; i++) {
			// LAYER は何行目か
					if (line1[i].length()==5 && (line1[i].substring(0,5)).equals("LAYER")) {	// LAYER を探す
						if (ltno1==0) {
							ltno1=i-4 ; 										// LAYERデータの開始行
//							System.out.printf("%d %s%n",ltno1,line1[ltno1]) ;
						}

						do {
									i++;
							if (line1[i].length()==3) {
									msg = line1[i].substring(0,3) ;
									ltno2=i+1 ; 								// LAYERデータの終了行	
							}
						} while (!msg.equals("  0")) ;							// "  0"の行が LAYERデータの終端なので、その行まで代入する
					}

			// ENTITIES は何行目か
				if (line1[i].length()==nsecti[0]) {
						msg = line1[i].substring(0,nsecti[0]) ;
					if (msg.equals(secti[0])) {									// ENTITIES を探す
						entino = i ;											// ENTITIES の開始行
//						System.out.printf("ENTITIESの位置= %6d%n",entino) ;
					}
				}
			
			// OBJECTS は何行目か
			if (line1[i].length()==nsecti[6]) {
					msg = line1[i].substring(0,nsecti[6]) ;
				if (msg.equals(secti[6])) {										// OBJECTS を探す
					objeno = i ;												// OBJECTS の開始行
//					System.out.printf("ENTITIESの位置= %6d%n",entino) ;
				}
			}
		}
					int kosu = grcodeY.length ;									// グループコードの個数
			// レイヤーの諸元の抽出
			for(int i = ltno1 ; i < ltno2 ; i++) {
				if (line1[i].length()==nsecti[1] && line1[i].substring(0,nsecti[1]).equals(secti[1])) {	// 各々のLAYER データの開始行
							nore=nore+1 ;
							printy[nore]=1 ;
						do {
									i++;
							if (line1[i].length()==3) {
									msg = line1[i].substring(0,3) ;
								for(int l = 0 ; l < kosu ; l++) {
									if (msg.equals(grcodeY[l])) {
										if (l==0) {
												i++ ;
											nalayer[nore]=line1[i] ;							// 画層名
//											System.out.printf(" %6d  %3d %s%n",i,nore,nalayer[nore]);
										} else if (l==1) {
												i++ ;
											irnola[nore] = (int) Double.parseDouble(line1[i]);	// 色番号
//											System.out.printf(" %6d  %3d %d%n",i,nore,irnola[nore]);
										} else if (l==2) {
												i++ ;
											selayer[nore]=line1[i].toUpperCase();				// 線種名
//											System.out.printf(" %6d  %3d %s%n",i,nore,selayer[nore]);
										} else if (l==3) {
											i++ ;
											printy[nore] = (int) Double.parseDouble(line1[i]);	// 印刷有無
//											System.out.printf(" %6d  %3d %d%n",i,nore,printy[nore]);
										} else if (l==4) {
												i++ ;
											futosa[nore] = (int) Double.parseDouble(line1[i]);	// 線太さ
//											System.out.printf(" %6d  %3d %d%n",i,nore,futosa[nore]);
											break ;
										}
									}
								}
							}
						} while (!msg.equals("  0")) ;											// 各々のLAYER データの終了行
							pw.printf("%d,%s,%d,%s,%d,%d%n",nore+1,nalayer[nore],irnola[nore],selayer[nore],futosa[nore],printy[nore]);	// LAYERデータの書き込み
//							System.out.printf("%d,%s,%d,%s,%d,%d%n",nore+1,nalayer[nore],irnola[nore],selayer[nore],futosa[nore],printy[nore]);
				}
			}
				pw.close();																		// ファイルのクローズ
				norep = nore+1 ;																// LAYER の個数

		// エラーがあった場合
		} catch(FileNotFoundException e) {
			System.out.println("ファイルがありません(LAYER)");
		} catch(IOException e) {
			System.out.println("入出力エラーです(LAYER)");
		}
	}

	// STYLEデータの書き込み	
	public void styleExtraction() {
		// 文字スタイル諸元の抽出
		try {
			FileOutputStream fos = new FileOutputStream(pathn+"0_文字スタイル.csv");	// 書き込みファイルの定義
			OutputStreamWriter out = new OutputStreamWriter(fos,"SJIS");			// 書き込み時の文字コードの定義
			PrintWriter pw = new PrintWriter(out);									// 1行単位の書き込みを定義
						int nore = -1 ;
				pw.printf("%s,%s,%s,%s,%s,%s,%s,%s,%s,%s%n","No","文字スタイル名","文字の高さ","幅係数","傾斜角度","最後の高さ","1フォント名","2フォント名","TrueType","左記フラグ") ;			// データ名
				pw.printf("%s,%d,%d,%d,%d,%d,%d,%d,%d,%d%n","G-code",2       ,40          ,41      ,50        ,42          ,3            ,4            ,1000      ,1071) ;	// グループコード

				int ltno1=0 , ltno2=0 ;
			for(int i = 0 ; i < noca ; i++) {
			// STYLE は何行目か
					if (line1[i].length()==5 && (line1[i].substring(0,5)).equals("STYLE")) {	// STYLE を探す
						if (ltno1==0) {
							ltno1=i-4 ; 														// STYLEデータ の開始行
//							System.out.printf("%d %s%n",ltno1,line1[ltno1]) ;
						}

						do {
									i++;
							if (line1[i].length()==3) {
									msg = line1[i].substring(0,3) ;
									ltno2=i+1 ; 												// STYLEデータ の終了行

							}
						} while (!msg.equals("  0")) ;											// "  0"の行が STYLEデータの終端なので、その行まで代入する
//						System.out.printf("%d %s%n",ltno2,line1[ltno2]) ;
					}
			}
//			System.out.println(nsecti[5]) ;
//			System.out.println(secti[5]) ;
					int kosu = grcodeS.length ;													// グループコードの個数
			// 文字スタイル諸元の抽出
			for(int i = ltno1 ; i < ltno2 ; i++) {
				if (line1[i].length()==nsecti[5] && line1[i].substring(0,nsecti[5]).equals(secti[5])) {
							nore=nore+1 ;
						do {
									i++;
							if (line1[i].length()==3) {
									msg = line1[i].substring(0,3) ;
								for(int l = 0 ; l < kosu ; l++) {
									if (msg.equals(grcodeS[l])) {
										if (l==0) {
												i++ ;
												if (line1[i].length()==0) {
													s2[nore]=ccc ;
												} else {
													s2[nore]=line1[i] ;							// 文字スタイル名
												}
//											System.out.println(s2[nore]) ;
										} else if (l==1) {
												i++ ;
											d40[nore] = Double.parseDouble(line1[i]);			// 高さ
										} else if (l==2) {
												i++ ;
											d41[nore]= Double.parseDouble(line1[i]);			// 幅係数
										} else if (l==3) {
											i++ ;
											d50[nore] = Double.parseDouble(line1[i]);			// 傾斜角度
										} else if (l==4) {
												i++ ;
											d42[nore] = Double.parseDouble(line1[i]);			// 最後に使用された高さ
										} else if (l==5) {
												i++ ;
											if (line1[i].length()==0) {
												s3[nore]=ccc ;
											} else {
												s3[nore] = line1[i] ;							// 1バイトフォント名
											}
										} else if (l==6) {
												i++ ;
											if (line1[i].length()==0) {
												s4[nore]=ccc ;
											} else {
												s4[nore] = line1[i] ;							// 2バイトフォント名
											}
										}
									}
								}
							}

							if (line1[i].length()==4) {
									msg = line1[i].substring(0,4) ;
								for(int l = 7 ; l < 9 ; l++) {
									if (msg.equals(grcodeS[l])) {
										if (l==7) {
												i++ ;
											if (line1[i].length()==0) {
												s1000[nore]=ccc ;
											} else {
												s1000[nore]=line1[i] ;							// TrueTypeフォント
											}
										} else if (l==8) {
												i++ ;
											i1071[nore] = (int) Double.parseDouble(line1[i]);	// フラグ
										}
									}
								}
							}
						} while (!msg.equals("  0")) ;											// "  0"の行が STYLEデータの終端なので、その行まで代入する
				}
			}
							nores = nore+1 ;
			for(int i = 0 ; i < nores ; i++) {
				pw.printf("%d,%s,%f,%f,%f,%f,%s,%s,%s,%d%n",i+1,s2[i],d40[i],d41[i],d50[i],d42[i],s3[i],s4[i],s1000[i],i1071[i]);	// STYLEデータの書き込み
			}
				pw.close();																		// ファイルのクローズ
		// エラーがあった場合
		} catch(FileNotFoundException e) {
			System.out.println("ファイルがありません(文字スタイル)");
		} catch(IOException e) {
			System.out.println("入出力エラーです(文字スタイル)");
		}
	}

	// 線分LINERデータの書き込み
	public void AcDbLine() {
				int nos = 0 ;
				String filename = pathn+koumk[nos]+".csv" ;
		try {
				FileOutputStream fos = new FileOutputStream(filename);			// 書き込みファイルの定義
				OutputStreamWriter out = new OutputStreamWriter(fos,"SJIS");	// 書き込み時の文字コードの定義
				PrintWriter pw = new PrintWriter(out);							// 1行単位の書き込みを定義
						int nore = -1 ;
						int kosu = grcodeL.length ;								// グループコードの個数
				pw.printf("%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s%n","No","始点x","y","z","終点x","y","z","線太さ","色番号","線種名","レーヤー名") ;	// データ名
				pw.printf("%s,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d%n","G-code",10,20 ,30 ,11     ,21 ,31 ,370     ,62      ,6       ,8) ;		// グループコード

			// 描画図形・文字等、すべての諸元の抽出	
			for(int i = entino ; i < objeno ; i++) {
					if (line1[i].length()==nkubet[nos] && line1[i].substring(0,nkubet[nos]).equals(kubet[nos])) {	// LINE を探す
								nore=nore+1 ;
						// Lineの諸元の抽出
						do {
									i++;
//									System.out.println(i) ;
							if (line1[i].length()==3) {
									msg = line1[i].substring(0,3) ;
								for(int l = 0 ; l < kosu ; l++) {
									if (msg.equals(grcodeL[l])) {
										if (l==0) {
												i++ ;
//												System.out.printf("%d %d %s%n",i,nore,line1[i]) ;
											nalayer0[nore]=line1[i] ;							// 画層名
										} else if (l==1) {
												i++ ;
											selayer0[nore]=line1[i].toUpperCase() ;				// 線種名
										} else if (l==2) {
												i++ ;
											irnola0[nore] = (int) Double.parseDouble(line1[i]);	// 色番号
										} else if (l==3) {
											i++ ;
											i370[nore] = (int) Double.parseDouble(line1[i]);	// 色番号
										} else if (l==4) {
												i++ ;
											x1[nore] = Double.parseDouble(line1[i]);			// 始点座標 x
										} else if (l==5) {
												i++ ;
											y1[nore] = Double.parseDouble(line1[i]);			// 始点座標 y
										} else if (l==6) {
												i++ ;
											z1[nore] = Double.parseDouble(line1[i]);			// 始点座標 z
										} else if (l==7) {
												i++ ;
											x2[nore] = Double.parseDouble(line1[i]);			// 終点座標 x
										} else if (l==8) {
												i++ ;
											y2[nore] = Double.parseDouble(line1[i]);			// 終点座標 y
										} else if (l==9) {
												i++ ;
											z2[nore] = Double.parseDouble(line1[i]);			// 終点座標 z
										}
									}
								}
							}
						} while (!(msg.equals("  0")) || line1[i].length()!=3 ) ;				// "  0"の行がデータの終端なので、その行まで代入する
				}
			}
			for(int l = 0 ; l < norep ; l++) {
				for(int i = 0 ; i < nore+1 ; i++) {
					if (nalayer[l].equals(nalayer0[i])) {
						pw.printf("%d,%f,%f,%f,%f,%f,%f,%d,%d,%s,%s%n",i+1,x1[i],y1[i],z1[i],x2[i],y2[i],z2[i],i370[i],irnola0[i],selayer0[i],nalayer0[i]);	// LINEデータの書き込み
					}
				}
			}
				pw.close();																		// ファイルのクローズ
		// エラーがあった場合
		} catch(FileNotFoundException e) {
			System.out.println("ファイルがありません(線分)");
		} catch(IOException e) {
			System.out.println("入出力エラーです(線分)");
		}		
	}

	// ポリラインデータの書き込み
	public void AcDbPolyline() {
				int nos = 1 ;
				String filename = pathn+koumk[nos]+".csv" ;
//				System.out.println(nkubet[nos]) ;
//				System.out.println(kubet[nos]) ;
		try {
				FileOutputStream fos = new FileOutputStream(filename);			// 書き込みファイルの定義
				OutputStreamWriter out = new OutputStreamWriter(fos,"SJIS");	// 書き込み時の文字コードの定義
				PrintWriter pw = new PrintWriter(out);							// 1行単位の書き込みを定義
					int nore = -1 ;
					int kosu = grcodeP.length ;									// グループコードの個数
			for(int i = entino ; i < objeno ; i++) {
				// AcDbEntity は何行目か
					if (line1[i].length()==nkubet[nos] && line1[i].substring(0,nkubet[nos]).equals(kubet[nos])) {
//						System.out.println(i) ;
									nore=nore+1 ;
									int k = -1 ;
						do {
									i++;
							if (line1[i].length()==3) {
									msg = line1[i].substring(0,3) ;
								for(int l = 0 ; l < kosu ; l++) {
									if (msg.equals(grcodeP[l])) {
										if (l==0) {
												i++ ;
											nalayer0[nore]=line1[i] ;							// 画層名
										} else if (l==1) {
												i++ ;
											selayer0[nore]=line1[i].toUpperCase();				// 線種名
										} else if (l==2) {
												i++ ;
											irnola0[nore] = (int) Double.parseDouble(line1[i]);	// 色番号
										} else if (l==3) {
											i++ ;
											i370[nore] = (int) Double.parseDouble(line1[i]);	// 線太さ
										} else if (l==4) {
												i++ ;
											double f1 = Double.parseDouble(line1[i]);
											pkous[nore] = (int) f1 ;							// 頂点の数
										} else if (l==5) {
												i++ ;
											double f1 = Double.parseDouble(line1[i]);
											tojik[nore] = (int) f1 ;							// 0：閉じない , 1：閉じる
//											pw.printf("%d%s%d%s%d%s%d%s%s%s%s%n",nore,c,pkous[nore],c,tojik[nore],c,irnola1[nore],c,selayer1[nore],c,nalayer1[nore]);
											pw.printf("%d,%d,%d,%d,%d,%s,%s,%s,%s,%s,%s,%s,%s,%s%n",nore+1,pkous[nore],tojik[nore],i370[nore],irnola0[nore],selayer0[nore],nalayer0[nore],"No","頂点の個数","終端部処理フラグ","線太さ","色番号","線種名","レーヤー名");
										} else if (l==6) {
												i++ ;
												k++ ;
//												System.out.printf("%d %d %d%n",i,nore,k) ;
											x3[nore][k] = Double.parseDouble(line1[i]);			// 頂点座標 x
										} else if (l==7) {
												i++ ;
											y3[nore][k] = Double.parseDouble(line1[i]);			// 頂点座標 y
//											pw.printf("%d%s%f%s%f%n",k+1,c,x3[nore][k],c,y3[nore][k]);
											if (k==0) {
												pw.printf("%d,%f,%f,%s%n",k+1,x3[nore][k],y3[nore][k],",,,,i,頂点の座標x,y") ;
											} else {
												pw.printf("%d,%f,%f%n",k+1,x3[nore][k],y3[nore][k]);
											}
										}
									}
								}
							}
						} while (!(msg.equals("  0")) || line1[i].length()!=3 ) ;				// "  0"の行がデータの終端なので、その行まで代入する
					}
			}
				pw.close();																		// ファイルのクローズ
		// エラーがあった場合
		} catch(FileNotFoundException e) {
			System.out.println("ファイルがありません(ポリライン)");
		} catch(IOException e) {
			System.out.println("入出力エラーです(ポリライン)");
		}
	}

	// 円・円弧データの書き込み
	public void AcDbCircle() {
			int nos = 2 ;
			String filename = pathn+koumk[nos]+".csv" ;
		try {
			FileOutputStream fos = new FileOutputStream(filename);			// 書き込みファイルの定義
			OutputStreamWriter out = new OutputStreamWriter(fos,"SJIS");	// 書き込み時の文字コードの定義
			PrintWriter pw = new PrintWriter(out);							// 1行単位の書き込みを定義
					int nore = -1 ;
					int kosu = grcodeC.length ;								// グループコードの個数
				pw.printf("%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s%n","No","中心x","y","z","半径","始点角度","終点角度","線太さ","色番号","線種名","レーヤー名") ;	// データ名
				pw.printf("%s,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d%n","G-code",10,20 ,30 ,40    ,50        ,51        ,370     ,62      ,6       ,8) ;		// グループコード
			for(int i = entino ; i < objeno ; i++) {
					if ((line1[i].length()==nkubet[nos] && line1[i].substring(0,nkubet[nos]).equals(kubet[nos]))
						|| (line1[i].length()==nkubet[7] && line1[i].substring(0,nkubet[7]).equals(kubet[7]))) {
//						System.out.printf("%d %s%n",i,line1[i]);
							nore=nore+1 ;
						do {
										i++;
							if (line1[i].length()==3) {
										msg = line1[i].substring(0,3) ;
								for(int l = 0 ; l < kosu ; l++) {
									if (msg.equals(grcodeC[l])) {
										if (l==0) {
												i++ ;
											nalayer0[nore]=line1[i] ;							// 画層名
										} else if (l==1) {
												i++ ;
											selayer0[nore]=line1[i].toUpperCase();				// 線種名
										} else if (l==2) {
												i++ ;
											irnola0[nore] = (int) Double.parseDouble(line1[i]);	// 色番号
										} else if (l==3) {
											i++ ;
											i370[nore] = (int) Double.parseDouble(line1[i]);	// 色番号
										} else if (l==4) {
												i++ ;
											x1[nore] = Double.parseDouble(line1[i]);			// 中心座標 x
										} else if (l==5) {
												i++ ;
											y1[nore] = Double.parseDouble(line1[i]);			// 中心座標 y
										} else if (l==6) {
												i++ ;
											z1[nore] = Double.parseDouble(line1[i]);			// 中心座標 z
										} else if (l==7) {
												i++ ;
											d40[nore] = Double.parseDouble(line1[i]);			// 半径
										} else if (l==8) {
												i++ ;
											d50[nore] = Double.parseDouble(line1[i]);			// 開始角度
										} else if (l==9) {
												i++ ;
											d51[nore] = Double.parseDouble(line1[i]);			// 終了角度
										}
									}
								}
							}
						} while (!(msg.equals("  0")) || line1[i].length()!=3 ) ;				// "  0"の行がデータの終端なので、その行まで代入する
					}
			}

			for(int l = 0 ; l < norep ; l++) {
				for(int i = 0 ; i < nore+1 ; i++) {
					if (nalayer[l].equals(nalayer0[i])) {
						pw.printf("%d,%f,%f,%f,%f,%f,%f,%d,%d,%s,%s%n",i+1,x1[i],y1[i],z1[i],d40[i],d50[i],d51[i],i370[i],irnola0[i],selayer0[i],nalayer0[i]);	// 円・円弧データの書き込み
//																      ,0  ,10   ,20   ,30   ,40    ,50    ,51    ,370    ,62        ,6          ,8) ;
//																      %d  ,%f   ,%f   ,%f   ,%f    ,%f    ,%f    ,%d     ,%d        ,%s         ,%s%n
					}
				}
			}
				pw.close();																		// ファイルのクローズ
		// エラーがあった場合
		} catch(FileNotFoundException e) {
			System.out.println("ファイルがありません(円・円弧)");
		} catch(IOException e) {
			System.out.println("入出力エラーです(円・円弧)");
		}
	}

	// テキストデータの書き込み
	public void AcDbText() {
				int nos = 3 ;
				String filename = pathn+koumk[nos]+".csv" ;
		try {
				FileOutputStream fos = new FileOutputStream(filename);			// 書き込みファイルの定義
				OutputStreamWriter out = new OutputStreamWriter(fos,"SJIS");	// 書き込み時の文字コードの定義
				PrintWriter pw = new PrintWriter(out);							// 1行単位の書き込みを定義
					int nore = -1 ;
					int kosu = grcodeT.length ;									// グループコードの個数
				pw.printf("%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s%n","No","ダミーx","y","z","高さ","文字列","回転角度","幅係数","傾斜角度","スタイル","横72","基準座標x","y","z","縦73","線太さ","色番号","線種名","レーヤー名") ;	// データ名
				pw.printf("%s,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d%n","G-code",10 ,20 ,30 ,40    ,1       ,50        ,41      ,51        ,7         ,72    ,11         ,21 ,31 ,73    ,370     ,62      ,6       ,8) ;	// グループコード
//									                     i+1  ,x1[i],y1[i],z1[i],d40[i],s1[i]   ,d50[i]    ,d41[i]  ,d51[i]    ,s7[i]     ,i72[i],x2[i]      ,y2[i],z2[i],i73[i],i370[i],irnola0[i],selayer0[i],nalayer0[i]) ;

			for(int i = entino ; i < objeno ; i++) {
				// AcDbEntity は何行目か
					if (line1[i].length()==nkubet[nos] && line1[i].substring(0,nkubet[nos]).equals(kubet[nos])) {
							nore=nore+1 ;
						do {
									i++;
							if (line1[i].length()==3) {
									msg = line1[i].substring(0,3) ;
								for(int l = 0 ; l < kosu ; l++) {
									if (msg.equals(grcodeT[l])) {
										if (l==0) {
												i++ ;
											nalayer0[nore]=line1[i] ;							// 画層名
										} else if (l==1) {
												i++ ;
											selayer0[nore]=line1[i].toUpperCase();				// 線種名
										} else if (l==2) {
												i++ ;
											irnola0[nore] = (int) Double.parseDouble(line1[i]);	// 色番号
										} else if (l==3) {
											i++ ;
											i370[nore] = (int) Double.parseDouble(line1[i]);	// 線太さ
										} else if (l==4) {
												i++ ;
											x1[nore] = Double.parseDouble(line1[i]) ;			// ダミー座標 x
										} else if (l==5) {
												i++ ;
											y1[nore] = Double.parseDouble(line1[i]) ;			// ダミー座標 y
										} else if (l==6) {
												i++ ;
											z1[nore] = Double.parseDouble(line1[i]) ;			// ダミー座標 z
										} else if (l==7) {
												i++ ;
											d40[nore] = Double.parseDouble(line1[i]) ;			// 高さ
										} else if (l==8) {
												i++ ;
											s1[nore]=line1[i] ;									// 文字列
										} else if (l==9) {
												i++ ;
											d50[nore] = Double.parseDouble(line1[i]) ;			// 回転角度
										} else if (l==10) {
													i++ ;
											d41[nore] = Double.parseDouble(line1[i]) ;			// 幅係数
										} else if (l==11) {
												i++ ;
											d51[nore] = Double.parseDouble(line1[i]) ;			// 傾斜角度
										} else if (l==12) {
												i++ ;
											s7[nore]=line1[i] ;									// 文字スタイル
										} else if (l==13) {
												i++ ;
											i72[nore] = (int) Double.parseDouble(line1[i]);		// 水平方向の文字位置合わせ
										} else if (l==14) {
												i++ ;
											x2[nore] = Double.parseDouble(line1[i]) ;			// 文字列の座標 x
										} else if (l==15) {
												i++ ;
											y2[nore] = Double.parseDouble(line1[i]) ;			// 文字列の座標 y
										} else if (l==16) {
												i++ ;
											z2[nore] = Double.parseDouble(line1[i]) ;			// 文字列の座標 z
										} else if (l==17) {
												i++ ;
											i73[nore] = (int) Double.parseDouble(line1[i]);		// 鉛直方向の文字位置合わせ
										}
									}
								}
							}
						} while (!(msg.equals("  0")) || line1[i].length()!=3 ) ;				// "  0"の行がデータの終端なので、その行まで代入する
					}
			}

			for(int l = 0 ; l < norep ; l++) {
				for(int i = 0 ; i < nore+1 ; i++) {
					if (nalayer[l].equals(nalayer0[i])) {
							pw.printf("%d,%f,%f,%f,%f,%s,%f,%f,%f,%s,%d,%f,%f,%f,%d,%d,%d,%s,%s%n",
									i+1,x1[i],y1[i],z1[i],d40[i],s1[i],d50[i],d41[i],d51[i],s7[i],i72[i],x2[i],y2[i],z2[i],i73[i],i370[i],irnola0[i],selayer0[i],nalayer0[i]) ;	// テキストデータの書き込み
//                                                                         " 10"," 20"," 30"," 40","  1"," 50"   ," 41"," 51","  7"," 72"  ," 11"," 21"," 31"," 73"
//									%d ,%f   ,%f   ,%f   ,%f    ,%s   ,%f    ,%f    ,%f    ,%s   ,%d    ,%f   ,%f   ,%f   ,%d    ,%d     ,%d        ,%s         ,%s%n
					}
				}
			}
				pw.close();																		// ファイルのクローズ
		// エラーがあった場合
		} catch(FileNotFoundException e) {
			System.out.println("ファイルがありません(テキスト)");
		} catch(IOException e) {
			System.out.println("入出力エラーです(テキスト)");
		}
	}

	// マルチテキストデータの書き込み
	public void AcDbMText() {
				int nos = 4 ;
				String filename = pathn+koumk[nos]+".csv" ;
		try {
				FileOutputStream fos = new FileOutputStream(filename);			// 書き込みファイルの定義
				OutputStreamWriter out = new OutputStreamWriter(fos,"SJIS");	// 書き込み時の文字コードの定義
				PrintWriter pw = new PrintWriter(out);							// 1行単位の書き込みを定義
					int nore = -1 ;
					int kosu = grcodeM.length ;									// グループコードの個数
					pw.printf("%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s%n","No","基準座標x","y","z","高さ","回転角度","矩形幅","B回転角度","アタッチされる点","描画方向","文字列","文字スタイル","ベクトルx","y","z","行間スタイル","行間係数","線太さ","色番号","線種名","レーヤー名") ;	// データ名
					pw.printf("%s,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d%n","G-code",10    ,20 ,30 ,40    ,50        ,41      ,46         ,71                ,72        ,1       ,7             ,11         ,21 ,31 ,73            ,44        ,370     ,62      ,6       ,8) ;	// グループコード
//                                                                                                                  i+1,x1[i],y1[i],z1[i],d40[i],d50[i],         d41[i],d46[i],    i71[i],          i72[i],      s1[i],   s7[i],          x2[i],y2[i],z2[i]       ,i73[i],d44[i],i370[i],irnola1[i],selayer1[i],nalayer1[i]
			for(int i = entino ; i < objeno ; i++) {
					if (line1[i].length()==nkubet[nos] && line1[i].substring(0,nkubet[nos]).equals(kubet[nos])) {
//						System.out.println(i) ;
							nore=nore+1 ;
						do {
									i++;
							if (line1[i].length()==3) {
									msg = line1[i].substring(0,3) ;
								for(int l = 0 ; l < kosu ; l++) {
									if (msg.equals(grcodeM[l])) {
										if (l==0) {
												i++ ;
											nalayer0[nore]=line1[i] ;							// 画層名
										} else if (l==1) {
												i++ ;
											selayer0[nore]=line1[i].toUpperCase();				// 線種名
										} else if (l==2) {
												i++ ;
											irnola0[nore] = (int) Double.parseDouble(line1[i]);	// 色番号
										} else if (l==3) {
											i++ ;
											i370[nore] = (int) Double.parseDouble(line1[i]);	// 色番号
										} else if (l==4) {
												i++ ;
											x1[nore] = Double.parseDouble(line1[i]) ;			// 文字列の座標 x
										} else if (l==5) {
												i++ ;
											y1[nore] = Double.parseDouble(line1[i]) ;			// 文字列の座標 y
										} else if (l==6) {
												i++ ;
											z1[nore] = Double.parseDouble(line1[i]) ;			// 文字列の座標 z
										} else if (l==7) {
												i++ ;
											d40[nore] = Double.parseDouble(line1[i]) ;			// 文字の高さ
										} else if (l==8) {
												i++ ;
											d50[nore] = Double.parseDouble(line1[i]) ;			// 行間係数
										} else if (l==9) {
												i++ ;
											d41[nore] = Double.parseDouble(line1[i]) ;			// 参照矩形の幅
										} else if (l==10) {
												i++ ;
											d46[nore] = Double.parseDouble(line1[i]) ;			// 行間係数
										} else if (l==11) {
												i++ ;
											i71[nore] = (int) Double.parseDouble(line1[i]);		// アタッチされる点
										} else if (l==12) {
												i++ ;
											i72[nore] = (int) Double.parseDouble(line1[i]);		// 描画方向
										} else if (l==13) {
												i++ ;
											s1[nore]=line1[i] ;									// 文字列
										} else if (l==14) {
												i++ ;
											s7[nore]=line1[i] ;									// 文字列
										} else if (l==15) {
												i++ ;
											x2[nore] = Double.parseDouble(line1[i]) ;			// 文字列の座標 x
										} else if (l==16) {
												i++ ;
											y2[nore] = Double.parseDouble(line1[i]) ;			// 文字列の座標 y
										} else if (l==14) {
												i++ ;
											z2[nore] = Double.parseDouble(line1[i]) ;			// 文字列の座標 z
										} else if (l==18) {
												i++ ;
											i73[nore] = (int) Double.parseDouble(line1[i]);		// 行間スタイル
										} else if (l==19) {
												i++ ;
											d44[nore] = Double.parseDouble(line1[i]) ;			// 行間係数
										}
									}
								}
							}
						} while (!(msg.equals("  0")) || line1[i].length()!=3 ) ;				// "  0"の行がデータの終端なので、その行まで代入する
					}
			}

			for(int l = 0 ; l < norep ; l++) {
				for(int i = 0 ; i < nore+1 ; i++) {
					if (nalayer[l].equals(nalayer0[i])) {
							pw.printf("%d,%f,%f,%f,%f,%f,%f,%f,%d,%d,%s,%s,%f,%f,%f,%d,%f,%d,%d,%s,%s%n",
									i+1,x1[i],y1[i],z1[i],d40[i],d50[i],d41[i],d46[i],i71[i],i72[i],s1[i],s7[i],x2[i],y2[i],z2[i],i73[i],d44[i],i370[i],irnola0[i],selayer0[i],nalayer0[i]);	// マルチテキストデータの書き込み
//									%d ,%f   ,%f   ,%f   ,%f    ,%f    ,%f    ,%f    ,%d    ,%d    ,%s   ,%s   ,%f   ,%f   ,%f   ,%d    ,%f    ,%d     ,%d        ,%s         ,%s%n
					}
				}
			}
				pw.close();																		// ファイルのクローズ
		// エラーがあった場合
		} catch(FileNotFoundException e) {
			System.out.println("ファイルがありません(マルチテキスト)");
		} catch(IOException e) {
			System.out.println("入出力エラーです(マルチテキスト)");
		}
	}

	// 点データの書き込み
	public void AcDbPoint() {
			int nos = 5 ;
			String filename = pathn+koumk[nos]+".csv" ;
		try {
			FileOutputStream fos = new FileOutputStream(filename);			// 書き込みファイルの定義
			OutputStreamWriter out = new OutputStreamWriter(fos,"SJIS");	// 書き込み時の文字コードの定義
			PrintWriter pw = new PrintWriter(out);							// 1行単位の書き込みを定義
					int nore = -1 ;
					int kosu = grcodePO.length ;							// グループコードの個数
				pw.printf("%s,%s,%s,%s,%s,%s,%s,%s%n","No","中心x","y","z","線太さ","色番号","線種名","レーヤー名") ;	// データ名
				pw.printf("%s,%d,%d,%d,%d,%d,%d,%d%n","G-code",10,20 ,30 ,370     ,62      ,6       ,8) ;		// グループコード

			for(int i = entino ; i < objeno ; i++) {
					if (line1[i].length()==nkubet[nos] && line1[i].substring(0,nkubet[nos]).equals(kubet[nos])) {	// LINE
//						System.out.println(i);
							nore=nore+1 ;
						do {
										i++;
							if (line1[i].length()==3) {
										msg = line1[i].substring(0,3) ;
								for(int l = 0 ; l < kosu ; l++) {
									if (msg.equals(grcodePO[l])) {
										if (l==0) {
												i++ ;
											nalayer0[nore]=line1[i] ;							// 画層名
										} else if (l==1) {
												i++ ;
											selayer0[nore]=line1[i].toUpperCase();				// 線種名
										} else if (l==2) {
												i++ ;
											irnola0[nore] = (int) Double.parseDouble(line1[i]);	// 色番号
										} else if (l==3) {
											i++ ;
											i370[nore] = (int) Double.parseDouble(line1[i]);	// 色番号
										} else if (l==4) {
												i++ ;
											x1[nore] = Double.parseDouble(line1[i]);			// 中心座標 x
										} else if (l==5) {
												i++ ;
											y1[nore] = Double.parseDouble(line1[i]);			// 中心座標 y
										} else if (l==6) {
												i++ ;
											z1[nore] = Double.parseDouble(line1[i]);			// 中心座標 z
										}
									}
								}
							}
						} while (!(msg.equals("  0")) || line1[i].length()!=3 ) ;				// "  0"の行がデータの終端なので、その行まで代入する
					}
			}
			for(int l = 0 ; l < norep ; l++) {
				for(int i = 0 ; i < nore+1 ; i++) {
					if (nalayer[l].equals(nalayer0[i])) {
							pw.printf("%d,%f,%f,%f,%d,%d,%s,%s%n",i+1,x1[i],y1[i],z1[i],i370[i],irnola0[i],selayer0[i],nalayer0[i]);	// 点データの書き込み
//																  %d ,%f   ,%f   ,%f   ,%d     ,%d        ,%s         ,%s%n
					}
				}
			}
				pw.close();																		// ファイルのクローズ
		// エラーがあった場合
		} catch(FileNotFoundException e) {
			System.out.println("ファイルがありません(点)");
		} catch(IOException e) {
			System.out.println("入出力エラーです(点)");
		}
	}

	// 楕円データの書き込み
	public void AcDbEllipse() {
			int nos = 6 ;
			String filename = pathn+koumk[nos]+".csv" ;
		try {
			FileOutputStream fos = new FileOutputStream(filename);			// 書き込みファイルの定義
			OutputStreamWriter out = new OutputStreamWriter(fos,"SJIS");	// 書き込み時の文字コードの定義
			PrintWriter pw = new PrintWriter(out);							// 1行単位の書き込みを定義
					int nore = -1 ;
					int kosu = grcodeEl.length ;							// グループコードの個数

				pw.printf("%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s%n","No","中心x","y","z","長軸x","y","z","比率","開始角度","終了角度","線太さ","色番号","線種名","レーヤー名") ;	// データ名
				pw.printf("%s,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d%n","G-code",10,20 ,30  ,11    ,21 ,31 ,40    ,41        ,42        ,370     ,62      ,6       ,8) ;	// グループコード
//                                                                                      i+1,x1[i],y1[i],z1[i],x2[i],y2[i],z2[i],d40[i],d41[i],d42[i],     i370[i],irnola0[i],selayer0[i],nalayer0[i]

			for(int i = entino ; i < objeno ; i++) {
					if (line1[i].length()==nkubet[nos] && line1[i].substring(0,nkubet[nos]).equals(kubet[nos])) {
//						System.out.println(i);
							nore=nore+1 ;
						do {
										i++;
							if (line1[i].length()==3) {
										msg = line1[i].substring(0,3) ;
								for(int l = 0 ; l < kosu ; l++) {
									if (msg.equals(grcodeEl[l])) {
										if (l==0) {
												i++ ;
											nalayer0[nore]=line1[i] ;							// 画層名
										} else if (l==1) {
												i++ ;
											selayer0[nore]=line1[i].toUpperCase();				// 線種名
										} else if (l==2) {
												i++ ;
											irnola0[nore] = (int) Double.parseDouble(line1[i]);	// 色番号
										} else if (l==3) {
											i++ ;
											i370[nore] = (int) Double.parseDouble(line1[i]);	// 線太さ
										} else if (l==4) {
												i++ ;
											x1[nore] = Double.parseDouble(line1[i]);			// 中心座標 x
										} else if (l==5) {
												i++ ;
											y1[nore] = Double.parseDouble(line1[i]);			// 中心座標 y
										} else if (l==6) {
												i++ ;
											z1[nore] = Double.parseDouble(line1[i]);			// 中心座標 z
										} else if (l==7) {
												i++ ;
											x2[nore] = Double.parseDouble(line1[i]);			// 半径
										} else if (l==8) {
												i++ ;
											y2[nore] = Double.parseDouble(line1[i]);			// 中心座標 y
										} else if (l==9) {
												i++ ;
											z2[nore] = Double.parseDouble(line1[i]);			// 中心座標 z
										} else if (l==10) {
												i++ ;
											d40[nore] = Double.parseDouble(line1[i]);			// 中心座標 y
										} else if (l==11) {
												i++ ;
											d41[nore] = Double.parseDouble(line1[i]);			// 中心座標 z

										} else if (l==12) {
												i++ ;
											d42[nore] = Double.parseDouble(line1[i]);			// 中心座標 y
										}
									}
								}
							}
						} while (!(msg.equals("  0")) || line1[i].length()!=3 ) ;				// "  0"の行がデータの終端なので、その行まで代入する
					}
			}

			for(int l = 0 ; l < norep ; l++) {
				for(int i = 0 ; i < nore+1 ; i++) {
					if (nalayer[l].equals(nalayer0[i])) {
						pw.printf("%d,%f,%f,%f,%f,%f,%f,%f,%f,%f,%d,%d,%s,%s%n",i+1,x1[i],y1[i],z1[i],x2[i],y2[i],z2[i],d40[i],d41[i],d42[i],i370[i],irnola0[i],selayer0[i],nalayer0[i]);	// 楕円データの書き込み
//																				%d ,%f   ,%f   ,%f   ,%f   ,%f   ,%f   ,%f    ,%f    ,%f    ,%d     ,%d        ,%s         ,%s%n
					}
				}
			}
				pw.close();																		// ファイルのクローズ
		// エラーがあった場合
		} catch(FileNotFoundException e) {
			System.out.println("ファイルがありません(楕円)");
		} catch(IOException e) {
			System.out.println("入出力エラーです(楕円)");
		}
	}
	
	// 変数の初期値の設定
	public void memor() {
		for(int i = 0 ; i < 100000 ; i++) {
			nalayer0[i] = "null" ;			// ENTITIESのLAYER名称(個々)
			selayer0[i] = "null" ;			// ENTITIESの線種(個々)
			irnola0[i] = 0 ;				// ENTITIESの色番号(個々)

			s1[i] = "null" ;				// 文字列
			s7[i] = "null" ;				// 文字スタイル

			d40[i] = 0 ;					// 文字の高さ
			d41[i] = 0 ;					// 参照矩形の幅
			d42[i] = 0 ;					// 終点角度
			d44[i] = 0 ;					// マルチテキスト行間隔係数
			d46[i] = 0 ;					// ブロックの回転角度

			d50[i] = 0 ;					// 文字の回転角度
			d51[i] = 0 ;					// 文字の傾斜角度

			i370[i] = 0 ;					// 線太さ
			i71[i] = 0 ;					// マルチテキスト アタッチされる点
			i72[i] = 0 ;					// 水平方向の文字位置合わせ
			i73[i] = 0 ;					// 垂直位置合わせ
		}
		
		for(int i = 0 ; i < 50000 ; i++) {
			pkous[i] = 0 ;					// ポリラインの頂点数
			tojik[i] = 0 ;					// ポリラインの終端処理(閉じる閉じない)
			x1[i] = 0 ;						// 始点ｘ
			y1[i] = 0 ;						// 始点ｙ
			z1[i] = 0 ;						// 始点ｚ
			x2[i] = 0 ;						// 終点ｘ
			y2[i] = 0 ;						// 終点ｙ
			z2[i] = 0 ;						// 終点ｚ
		}

		for(int i = 0 ; i < 1000 ; i++) {
			for(int l = 0 ; l < 250 ; l++) {
				x3[i][l] = 0 ;				// ポリラインの頂点ｘ
				y3[i][l] = 0 ;				// ポリラインの頂点ｙ
			}
		}

	}
}
