/*
 *  データからdxf(ver2013)ファイルを作成する(ｄｘｆ命令書き出しのライブラリー)
 *    LAYER,SYTLE,LINE,LWPOLYLINE,CIRCLE(円・円弧),TEXT,MTEXT,POINT,ELLIPSE
 */
// JREシステムライブラリー
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;

public class DxfR2013 {
		protected static PrintWriter pw;

	public void layer_fs() {														// LAYERファイルのオープン
			try {
				FileOutputStream fos = new FileOutputStream(Dxfdraw2013.filems2);	// 書き込みファイルの定義
				OutputStreamWriter out = new OutputStreamWriter(fos,"SJIS");		// 書き込み時の文字コードの定義
				pw = new PrintWriter(out);											// 1行単位の書き込みを定義
			} catch(IOException e) {
				System.out.println("Error"); 
			}
		}
	
	public void style_fs() {														// STYLEファイルのオープン
		try {
			FileOutputStream fos = new FileOutputStream(Dxfdraw2013.filems3);		// 書き込みファイルの定義
			OutputStreamWriter out = new OutputStreamWriter(fos,"SJIS");			// 書き込み時の文字コードの定義
			pw = new PrintWriter(out);												// 1行単位の書き込みを定義
		} catch(IOException e) {
			System.out.println("Error"); 
		}
	}

	public void entities_s() {														// ENTITIESのオープン
			try {
				FileOutputStream fos = new FileOutputStream(Dxfdraw2013.filems4);	// 書き込みファイルの定義
				OutputStreamWriter out = new OutputStreamWriter(fos,"SJIS");		// 書き込み時の文字コードの定義
				pw = new PrintWriter(out);											// 1行単位の書き込みを定義
			} catch(IOException e) {
				System.out.println("Error"); 
			}
		}

	public void file_e() {															// ファイル の終了
			pw.close(); 															// ファイルのクローズ
	}

	public void endtab() {															// TAB の終了(LAYER , STYLE の終端)
			pw.println("  0") ;
			pw.println("ENDTAB") ;
	}

	public void table_layer_s(int isw , int mai) {									// LAYER の開始部
			pw.println("  0") ;
			pw.println("TABLE") ;
			pw.println("  2") ;
			pw.println("LAYER") ;
			pw.println("  5") ;
				String hex = Integer.toHexString(isw).toUpperCase();
			pw.println(hex) ;														// 16進数ハンドル番号
			pw.println("102") ;
			pw.println("{ACAD_XDICTIONARY") ;
			pw.println("360") ;
			pw.println("E6") ;
			pw.println("102") ;
			pw.println("}") ;
			pw.println("330") ;
			pw.println("0") ;
			pw.println("100") ;
			pw.println("AcDbSymbolTable") ;
			pw.println(" 70") ;
			pw.printf("%6d%n",mai) ; 												// レイヤー個数
	}

	public void table_layer(int isw,String aname, int noc , String sens , int hut , int pri) {	// LAYER の個々
			pw.println("  0") ;
			pw.println("LAYER") ;
			pw.println("  5") ;
				String hex = Integer.toHexString(isw).toUpperCase();
			pw.println(hex) ;				// 16進数ハンドル番号
			if (ha_ascii(aname)==1) {
				pw.println("102") ;
				pw.println("{ACAD_XDICTIONARY") ;
				pw.println("360") ;
				pw.println("E6") ;
				pw.println("102") ;
				pw.println("}") ;
			}
			pw.println("330") ;
			pw.println("2") ;
			pw.println("100") ;
			pw.println("AcDbSymbolTableRecord") ;
			pw.println("100") ;
			pw.println("AcDbLayerTableRecord") ;
			pw.println("  2") ;
			pw.println(aname) ;				// 画層名
			pw.println(" 70") ;
			pw.println("     0") ;
			pw.println(" 62") ;
			pw.printf("%6d%n",noc) ;		// 色
			pw.println("  6") ;
			pw.println(sens) ;				// 線種
			if (pri==0) {
				pw.println("290") ;
				pw.printf ("%6d%n",pri) ;	// 線の印刷
			}
			pw.println("370") ;
			pw.printf ("%6d%n",hut) ;		// 線太さ
			pw.println("390") ;
			pw.println("F") ;
			pw.println("347") ;
			pw.println("98") ;
			pw.println("348") ;
			pw.println("0") ;
	}

	public void table_style_s(int isw , int mai) {	// STYLE の開始部
			pw.println("  0") ;
			pw.println("TABLE") ;
			pw.println("  2") ;
			pw.println("STYLE") ;
			pw.println("  5") ;
				String hex = Integer.toHexString(isw).toUpperCase();
			pw.println(hex) ;				// 16進数ハンドル番号
			pw.println("330") ;
			pw.println("2") ;
			pw.println("100") ;
			pw.println("AcDbSymbolTable") ;
			pw.println(" 70") ;
			pw.printf("%6d%n",mai) ; 		// STYLE個数
	}

	public void table_style(int isw,String aname, double th40,double th41,double th50,double th42, 
							String nama3, String nama4, String namaa, int hut) {	// STYLE の個々
		if (aname.equals("null")) { return ;}
		
			pw.println("  0") ;
			pw.println("STYLE") ;
			pw.println("  5") ;
				String hex = Integer.toHexString(isw).toUpperCase();
			pw.println(hex) ;
			pw.println("330") ;
			pw.println("2") ;
			pw.println("100") ;
			pw.println("AcDbSymbolTableRecord") ;
			pw.println("100") ;
			pw.println("AcDbTextStyleTableRecord") ;
			pw.println("  2") ;
			if (aname.equals("null")) {
				pw.println("") ;
			} else {
				pw.println(aname) ;			// 文字スタイル名
			}
			pw.println(" 70") ;
			pw.println("     0") ;
			pw.println(" 40") ;
			pw.println(th40) ;				// 高さ
			pw.println(" 41") ;
			pw.println(th41) ;				// 幅係数
			pw.println(" 50") ;
			pw.println(th50) ;				// 傾斜角度

			pw.println(" 70") ;
			pw.println("     0") ;
			pw.println(" 42") ;
			pw.println(th42) ;				// 最後に使用された高さ
			pw.println("  3") ;
			if (nama3.equals("null")) {
				pw.println("") ;
			} else {
				pw.println(nama3) ;			// 1バイトコードのフォント名
			}
			
			pw.println("  4") ;
			if (nama4.equals("null")) {
				pw.println("") ;
			} else {
				pw.println(nama4) ;			// ２バイトコードのフォント名
			}

			if (hut!=0) {
					pw.println("1001") ;
					pw.println("ACAD") ;
					pw.println("1000") ;
				if (namaa.equals("null")) {
					pw.println("") ;
				} else {
					pw.println(namaa) ;		// TrueTypeフォント
				}
					pw.println("1071") ;
					pw.printf ("%6d%n",hut) ;
			}
	}

	public void entit_s() {					// ENTITIES Section の開始
			pw.println("  0") ;
			pw.println("SECTION") ;
			pw.println("  2") ;
			pw.println("ENTITIES") ;
	}

	// ENTITIES LINE
	public void entit_line(int isw,String aname,double xs,double ys,double zs,double xe,double ye,
							double ze, String namu , int ioc , int hut) {
			pw.println("  0") ;
			pw.println("LINE") ;
			pw.println("  5") ;
				String hex = Integer.toHexString(isw);
			pw.println(hex) ;				// 16進数ハンドル番号
			pw.println("330") ;
			pw.println("1F") ;
			pw.println("100") ;
			pw.println("AcDbEntity") ;
			pw.println("  8") ;
			pw.println(aname) ;				// 画層名
//			System.out.println(namu) ;
			if (namu.equals("gatti") || namu.equals("null")) {
			
			} else {
				pw.println("  6") ;
				pw.println(namu) ;			// 線種名
			}

			if (ioc!=0) {
				pw.println(" 62") ;
				pw.printf ("%6d%n",ioc) ;	// 色番号
			}

			if (hut!=0) {
				pw.println("370") ;
				pw.printf ("%6d%n",hut) ;	// 線太さ
			}

			pw.println("100") ;
			pw.println("AcDbLine") ;
			pw.println(" 10") ;
			pw.println(xs) ;				// 始点x値
			pw.println(" 20") ;
			pw.println(ys) ;				// 始点y値
			pw.println(" 30") ;
			pw.println(zs) ;				// 始点z値
			pw.println(" 11") ;
			pw.println(xe) ;				// 終点x値
			pw.println(" 21") ;
			pw.println(ye);					// 終点y値
			pw.println(" 31") ;
			pw.println(ze) ;				// 終点z値
	}

	// ENTITIES POLYLINE
	public int entit_polyline(int isw,String aname,int nn,int tj ,double []xp,double []yp,
								String namu , int ioc , int hut) {
			pw.println("  0") ;
			pw.println("LWPOLYLINE") ;
			pw.println("  5") ;
				String hex = Integer.toHexString(isw);
			pw.println(hex) ;				// 16進数ハンドル番号
			pw.println("330") ;
			pw.println("1F") ;
			pw.println("100") ;
			pw.println("AcDbEntity") ;
			pw.println("  8") ;
			pw.println(aname) ;				// 画層名
			if (namu.equals("gatti") || namu.equals("null")) {
				
			} else {
				pw.println("  6") ;
				pw.println(namu) ;			// 線種名
			}
			if (ioc!=0) {
				pw.println(" 62") ;
				pw.printf ("%6d%n",ioc) ;	// 色番号
			}
			if (hut!=0) {
				pw.println("370") ;
				pw.printf ("%6d%n",hut) ;	// 線太さ
			}

			pw.println("100") ;
			pw.println("AcDbPolyline") ;
			pw.println(" 90") ;
			pw.printf("%9d%n",nn) ;			// 頂点個数
			pw.println(" 70") ;
			pw.printf("%6d%n",tj) ;			// 閉じる閉じない
			pw.println(" 43") ;
			pw.println("0.0") ;

			for(int i = 0 ; i < nn ; i++) {
				pw.println(" 10") ;
				pw.println(xp[i]) ;			// x値
				pw.println(" 20") ;
				pw.println(yp[i]) ;			// y値
//				pw.println(" 30") ;
//				pw.println(zp[i]) ;			// z値
			}
				return isw ;
	}

	// ENTITIES CIRCLE / ARC
	public void entit_circle(int isw,String aname,double xs,double ys,double zs,double ha,
							double kstat , double kend, String namu , int ioc , int hut) {
			pw.println("  0") ;
			if (kstat==0 && kend==0) {
				pw.println("CIRCLE") ;
			} else {
				pw.println("ARC") ;
			}

			pw.println("  5") ;
				String hex = Integer.toHexString(isw);
			pw.println(hex) ;				// 16進数ハンドル番号
			pw.println("330") ;
			pw.println("1F") ;
			pw.println("100") ;
			pw.println("AcDbEntity") ;
			pw.println("  8") ;
			pw.println(aname) ;				// 画層名
			if (namu.equals("gatti") || namu.equals("null")) {
				
			} else {
				pw.println("  6") ;
				pw.println(namu) ;			// 線種名
			}

			if (ioc!=0) {
				pw.println(" 62") ;
				pw.printf ("%6d%n",ioc) ;	// 色番号
			}

			if (hut!=0) {
				pw.println("370") ;
				pw.printf ("%6d%n",hut) ;	// 線太さ
			}

			pw.println("100") ;
			pw.println("AcDbCircle") ;
			pw.println(" 10") ;
			pw.println(xs) ;				// x値
			pw.println(" 20") ;
			pw.println(ys) ;				// y値
			pw.println(" 30") ;
			pw.println(zs) ;				// z値
			pw.println(" 40") ;
			pw.println(ha) ;				// 半径
			if (kstat!=0 || kend!=0) {
				pw.println("100") ;
				pw.println("AcDbArc") ;
				pw.println(" 50") ;
				pw.println(kstat) ;			// 開始角度(°)
				pw.println(" 51") ;
				pw.println(kend) ;			// 終了角度(°)
			}
	}
	
	// ENTITIES TEXT
//									nalayer0[i]       x1[i]      ,y1[i]     ,z1[i]      d40[i]       ,s1[i],     d50[i],     d41[i],      d51[i],     s7[i],   i72[i],      x2[i],      y2[i],      z2[i],   i73[i],selayer0[i]  ,irnola0[i],i370[i]
	public void entit_text(int isw,String aname,double xs10,double ys20,double zs30,double th40,
							String amoji,double th50,double th41,double th51,String ss7,int iyoko,
							double xs11,double ys21,double zs31,int itate, String namu , int ioc , int hut) {
			pw.println("  0") ;
			pw.println("TEXT") ;
			pw.println("  5") ;
				String hex = Integer.toHexString(isw);
			pw.println(hex) ;				// 16進数ハンドル番号
			pw.println("330") ;
			pw.println("1F") ;
			pw.println("100") ;
			pw.println("AcDbEntity") ;
			pw.println("  8") ;
			pw.println(aname) ;				// 画層名
			if (namu.equals("gatti") || namu.equals("null")) {
					
			} else {
				pw.println("  6") ;
				pw.println(namu) ;			// 線種名
			}

			if (ioc!=0) {
				pw.println(" 62") ;
				pw.printf ("%6d%n",ioc) ;	// 色番号
			}

			if (hut!=0) {
				pw.println("370") ;
				pw.printf ("%6d%n",hut) ;	// 線太さ
			}

			pw.println("100") ;
			pw.println("AcDbText") ;
			pw.println(" 10") ;
			pw.println(xs10) ;				// x値：ダミー
			pw.println(" 20") ;
			pw.println(ys20) ;				// y値：ダミー
			pw.println(" 30") ;
			pw.println(zs30) ;				// z値：ダミー
			pw.println(" 40") ;
			pw.println(th40) ;				// 文字高さ
			pw.println("  1") ;
			pw.println(amoji) ;				// 文字
			if (th50!=0) {
				pw.println(" 50") ;
				pw.println(th50) ;			// 回転角度
			}
			if (itate==0 && iyoko==5) {
				pw.println(" 41") ;
				pw.println(th41) ;			// 幅係数
			}
			if (th51!=0) {
				pw.println(" 51") ;
				pw.println(th51) ;			// 傾斜角度
			}
			if (!ss7.equals("null")) {
				pw.println("  7") ;
				pw.println(ss7) ;			// 文字スタイル
			}


			if (itate==0 && iyoko==0) {
				pw.println("100") ;
				pw.println("AcDbText") ;
			} else {
				pw.println(" 72") ;
				pw.printf("%5d%n",iyoko) ; 	// 横位置合わせコード
				pw.println(" 11") ;
				pw.println(xs11) ;			// x値：基準点
				pw.println(" 21") ;
				pw.println(ys21);			// y値：基準点
				pw.println(" 31") ;
				pw.println(zs31) ;			// z値：基準点
				pw.println("100") ;
				pw.println("AcDbText") ;
				pw.println(" 73") ;
				pw.printf("%5d%n",itate) ;	// 縦位置合わせコード
			}
	}
	
	// ENTITIES TEXT
//	                                 nalayer0[i]     x1[i]    ,y1[i]    ,z1[i]    d40[i]      ,s1[i],     d50[i],     d41[i],      d51[i],     s7[i],   i72[i],      x2[i],      y2[i],      z2[i],   i73[i],selayer0[i]  ,irnola0[i],i370[i]
	public void entit_text2(int isw,String aname,double xs,double ys,double zs,double th,String amoji,
							double th50,double th41,double th51,String ss7,int iyoko,int itate,
							String namu , int ioc , int hut) {
			double tyu0=0.494923858d ;
			double tyu=0.324873096d ;
			double migi=0.649746193d ;
			double teihen=-0.182741117d ;
			double tyuou=0.5d ;
			double zyouhen=1d ;
			int nst1=0 ;
			double xs10=xs ;
			double ys20=ys ;
			double xs11=xs ;
			double ys21=ys ;

		try {
				nst1=amoji.getBytes("Shift-JIS").length ;
		} catch (UnsupportedEncodingException e) {
				e.printStackTrace();
		}

		if (itate==0) {
			if (iyoko==0) {
				xs10=xs ;
				ys20=ys ;
				xs11=xs ;
				ys21=ys ;
			} else if (iyoko==1) {
				xs10=xs-th*tyu*(double) nst1 ;
				ys20=ys ;
				xs11=xs ;
				ys21=ys ;
			} else if (iyoko==2) {
				xs10=xs-th*migi*(double) nst1 ;
				ys20=ys ;
				xs11=xs ;
				ys21=ys ;
			} else if (iyoko==3) {
				xs10=xs ;
				ys20=ys ;
				xs11=xs+th*migi ;
				ys21=ys ;
			} else if (iyoko==4) {
				xs10=xs-th*migi*(double) nst1/2 ;
				ys20=ys-th*tyu0 ;
				xs11=xs ;
				ys21=ys ;
			} else if (iyoko==5) {
				xs10=xs ;
				ys20=ys ;
				xs11=xs+th*migi;
				ys21=ys ;
			}
		} else if (itate==1){
			if (iyoko==0) {
				xs10=xs ;
				ys20=ys-th*teihen ;
				xs11=xs ;
				ys21=ys ;
			} else if (iyoko==1) {
				xs10=xs-th*tyu*(double) nst1 ;
				ys20=ys-th*teihen ;
				xs11=xs ;
				ys21=ys ;
			} else if (iyoko==2) {
				xs10=xs-th*migi*(double) nst1 ;
				ys20=ys-th*teihen ;
				xs11=xs ;
				ys21=ys ;
			}
		} else if (itate==2){
			if (iyoko==0) {
				xs10=xs ;
				ys20=ys-th*tyuou ;
				xs11=xs ;
				ys21=ys ;
			} else if (iyoko==1) {
				xs10=xs-th*tyu*(double) nst1 ;
				ys20=ys-th*tyuou ;
				xs11=xs ;
				ys21=ys ;
			} else if (iyoko==2) {
				xs10=xs-th*migi*(double) nst1 ;
				ys20=ys-th*tyuou ;
				xs11=xs ;
				ys21=ys ;
			}
		} else if (itate==3){
			if (iyoko==0) {
				xs10=xs ;
				ys20=ys-th*zyouhen ;
				xs11=xs ;
				ys21=ys ;
			} else if (iyoko==1) {
				xs10=xs-th*tyu*(double) nst1 ;
				ys20=ys-th*zyouhen ;
				xs11=xs ;
				ys21=ys ;
			} else if (iyoko==2) {
				xs10=xs-th*migi*(double) nst1 ;
				ys20=ys-th*zyouhen ;
				xs11=xs ;
				ys21=ys ;
			}
		}

			pw.println("  0") ;
			pw.println("TEXT") ;
			pw.println("  5") ;
				String hex = Integer.toHexString(isw);
			pw.println(hex) ;				// 16進数ハンドル番号
			pw.println("330") ;
			pw.println("1F") ;
			pw.println("100") ;
			pw.println("AcDbEntity") ;
			pw.println("  8") ;
			pw.println(aname) ;				// 画層名
			if (namu.equals("gatti") || namu.equals("null")) {
				
			} else {
				pw.println("  6") ;
				pw.println(namu) ;			// 線種名
			}
			if (ioc!=0) {
				pw.println(" 62") ;
				pw.printf ("%6d%n",ioc) ;	// 色番号
			}
			if (hut!=0) {
				pw.println("370") ;
				pw.printf ("%6d%n",hut) ;	// 線太さ
			}
			pw.println("100") ;
			pw.println("AcDbText") ;
			pw.println(" 10") ;
			pw.println(xs10) ;				// x値
			pw.println(" 20") ;
			pw.println(ys20) ;				// y値
			pw.println(" 30") ;
			pw.println(zs) ;				// z値
			pw.println(" 40") ;
		if (iyoko==3) {
			double thh=th/(double) nst1 ;
			pw.println(thh) ;				// 文字高さ
		} else {
			pw.println(th) ;				// 文字高さ
		}
			pw.println("  1") ;
			pw.println(amoji) ;				// 文字
		if (th50!=0) {
			pw.println(" 50") ;
			pw.println(th50) ;				// 回転角度
		}

		if (iyoko==5) {
			pw.println(" 41") ;
			double thh=1/(double) nst1 ;
			pw.println(thh) ;				// 幅係数
		}
		if (th51!=0) {
			pw.println(" 51") ;
			pw.println(th51) ;				// 傾斜角度
		}

		if (!ss7.equals("null")) {
			pw.println("  7") ;
			pw.println(ss7) ;				// 線種名
		}

			pw.println(" 72") ;
			pw.printf("%5d%n",iyoko) ; 		// 横位置合わせコード
			pw.println(" 11") ;
			pw.println(xs11) ;				// x値
			pw.println(" 21") ;
			pw.println(ys21);				// y値
			pw.println(" 31") ;
			pw.println(zs) ;				// z値
			pw.println("100") ;
			pw.println("AcDbText") ;
			pw.println(" 73") ;
			pw.printf("%5d%n",itate) ;		// 縦位置合わせコード
	}
	
	// ENTITIES TEXT
//	                                 nalayer0[i]     x1[i]    ,y1[i]    ,z1[i]    d40[i]      ,s1[i],     d50[i],     d41[i],      d51[i],     s7[i],   i72[i],      x2[i],      y2[i],      z2[i],   i73[i],selayer0[i]  ,irnola0[i],i370[i]
	public void entit_text3(int isw,String aname,double xs,double ys,double zs,double th,String amoji,
							double th50,double th41,double th51,String ss7,int iyoko,int itate,
							String namu , int ioc , int hut) {
			pw.println("  0") ;
			pw.println("TEXT") ;
			pw.println("  5") ;
				String hex = Integer.toHexString(isw);
			pw.println(hex) ;				// 16進数ハンドル番号
			pw.println("330") ;
			pw.println("1F") ;
			pw.println("100") ;
			pw.println("AcDbEntity") ;
			pw.println("  8") ;
			pw.println(aname) ;				// 画層名
			if (namu.equals("gatti") || namu.equals("null")) {
				
			} else {
				pw.println("  6") ;
				pw.println(namu) ;			// 線種名
			}
			if (ioc!=0) {
				pw.println(" 62") ;
				pw.printf ("%6d%n",ioc) ;	// 色番号
			}
			if (hut!=0) {
				pw.println("370") ;
				pw.printf ("%6d%n",hut) ;	// 線太さ
			}
			pw.println("100") ;
			pw.println("AcDbText") ;
			pw.println(" 10") ;
			pw.println(xs) ;				// x値
			pw.println(" 20") ;
			pw.println(ys) ;				// y値
			pw.println(" 30") ;
			pw.println(zs) ;				// z値
			pw.println(" 40") ;
			pw.println(th) ;				// 文字高さ
			pw.println("  1") ;
			pw.println(amoji) ;				// 文字列
			if (th50!=0) {
				pw.println(" 50") ;
				pw.println(th50) ;			// 回転角度
			}
			if (th41!=0) {
				pw.println(" 41") ;
				pw.println(th41) ;			// 幅係数
			}
			if (th51!=0) {
				pw.println(" 51") ;
				pw.println(th51) ;			// 傾斜角度
			}

			if (!ss7.equals("null")) {
				pw.println("  7") ;
				pw.println(ss7) ;			// 線種名
			}

			pw.println("100") ;
			pw.println("AcDbText") ;
	}

	// ENTITIES TEXT
	public void entit_mtext(int isw,String aname,double xs10,double ys20,double zs30,double th40,
							double th50,double th41,double th46 , int iko71,int iko72,String amoji,
							String mstyle,double xs11,double ys21,double zs31,int iko73,double th44,
							String namu , int ioc , int hut) {
			pw.println("  0") ;
			pw.println("MTEXT") ;
			pw.println("  5") ;
				String hex = Integer.toHexString(isw);
			pw.println(hex) ;				// 16進数ハンドル番号
			pw.println("330") ;
			pw.println("1F") ;
			pw.println("100") ;
			pw.println("AcDbEntity") ;
			pw.println("  8") ;
			pw.println(aname) ;				// 画層名
			if (namu.equals("gatti") || namu.equals("null")) {
					
			} else {
				pw.println("  6") ;
				pw.println(namu) ;			// 線種名
			}
			if (ioc!=0) {
				pw.println(" 62") ;
				pw.printf ("%6d%n",ioc) ;	// 色番号
			}
			if (hut!=0) {
				pw.println("370") ;
				pw.printf ("%6d%n",hut) ;	// 線太さ
			}

			pw.println("100") ;
			pw.println("AcDbMText") ;
			pw.println(" 10") ;
			pw.println(xs10) ;				// x値
			pw.println(" 20") ;
			pw.println(ys20) ;				// y値
			pw.println(" 30") ;
			pw.println(zs30) ;				// z値
			pw.println(" 40") ;
			pw.println(th40) ;				// 文字高さ
			if (th50!=0) {
				pw.println(" 50") ;
				pw.println(th50) ;			// 回転角度
			}

			pw.println(" 41") ;
			pw.println(th41) ;				// 参照矩形の幅
			pw.println(" 46") ;
			pw.println(th46) ;				// ブロックの回転角度

			pw.println(" 71") ;
			pw.printf("%6d%n",iko71) ; 		// アタッチされる点
			pw.println(" 72") ;
			pw.printf("%6d%n",iko72) ; 		// 描画方向

			pw.println("  1") ;
			pw.println(amoji) ;				// 文字列

			pw.println("  7") ;
			pw.println(mstyle) ;			// 文字スタイル名
			pw.println(" 11") ;
			pw.println(xs11) ;				// ベクトルx値
			pw.println(" 21") ;
			pw.println(ys21) ;				// ベクトルy値
			pw.println(" 31") ;
			pw.println(zs30) ;				// ベクトルz値
			pw.println(" 73") ;
			pw.printf("%6d%n",iko73) ; 		// 行間スタイル
			pw.println(" 44") ;
			pw.println(th44) ; 				// 行間係数

			pw.println("1001") ;
			pw.println("ACAD") ;
			pw.println("1000") ;
			pw.println("MTEXTBEGIN") ;
			pw.println("1070") ;
			pw.println("    73") ;
			pw.println("1070") ;
			pw.println("     1") ;
			pw.println("1070") ;
			pw.println("    44") ;
			pw.println("1040") ;
			pw.println("1.0") ;
			pw.println("1070") ;
			pw.println("    74") ;
			pw.println("1070") ;
			pw.println("     0") ;
			pw.println("1000") ;
			pw.println("MTEXTEND") ;
			pw.println("1000") ;
			pw.println("ACAD_MTEXT_DEFINED_HEIGHT_BEGIN") ;
			pw.println("1070") ;
			pw.println("    46") ;
			pw.println("1040") ;
			pw.println(th46) ;
			pw.println("1000") ;
			pw.println("ACAD_MTEXT_DEFINED_HEIGHT_END") ;
	}

	// ENTITIES POINT
	public void entit_point(int isw,String aname,double xs,double ys,double zs, String namu , int ioc , int hut) {
			pw.println("  0") ;
			pw.println("POINT") ;
			pw.println("  5") ;
				String hex = Integer.toHexString(isw);
			pw.println(hex) ;				// 16進数ハンドル番号
			pw.println("330") ;
			pw.println("1F") ;
			pw.println("100") ;
			pw.println("AcDbEntity") ;
			pw.println("  8") ;
			pw.println(aname) ;				// 画層名
			if (namu.equals("gatti") || namu.equals("null")) {
				
			} else {
				pw.println("  6") ;
				pw.println(namu) ;			// 線種名
			}

			if (ioc!=0) {
				pw.println(" 62") ;
				pw.printf ("%6d%n",ioc) ;	// 色番号
			}

			if (hut!=0) {
				pw.println("370") ;
				pw.printf ("%6d%n",hut) ;	// 線太さ
			}

			pw.println("100") ;
			pw.println("AcDbPoint") ;
			pw.println(" 10") ;
			pw.println(xs) ;				// x値
			pw.println(" 20") ;
			pw.println(ys) ;				// y値
			pw.println(" 30") ;
			pw.println(zs) ;				// z値
	}

	// ENTITIES ELLIPSE
	public void entit_ellipse(int isw,String aname,double xs,double ys,double zs,double xe,double ye,
								double ze,double ha,double kstat , double kend, String namu , int ioc , int hut) {
			pw.println("  0") ;
			pw.println("ELLIPSE") ;
			pw.println("  5") ;
				String hex = Integer.toHexString(isw);
			pw.println(hex) ;				// 16進数ハンドル番号
			pw.println("330") ;
			pw.println("1F") ;
			pw.println("100") ;
			pw.println("AcDbEntity") ;
			pw.println("  8") ;
			pw.println(aname) ;				// 画層名
			if (namu.equals("gatti") || namu.equals("null")) {
				
			} else {
				pw.println("  6") ;
				pw.println(namu) ;			// 線種名
			}

			if (ioc!=0) {
				pw.println(" 62") ;
				pw.printf ("%6d%n",ioc) ;	// 色番号
			}

			if (hut!=0) {
				pw.println("370") ;
				pw.printf ("%6d%n",hut) ;	// 線太さ
			}

			pw.println("100") ;
			pw.println("AcDbEllipse") ;
			pw.println(" 10") ;
			pw.println(xs) ;				// x値(中心)
			pw.println(" 20") ;
			pw.println(ys) ;				// y値(中心)
			pw.println(" 30") ;
			pw.println(zs) ;				// z値(中心)
			pw.println(" 11") ;
			pw.println(xe) ;				// x値(長軸の端点)
			pw.println(" 21") ;
			pw.println(ye) ;				// y値(長軸の端点)
			pw.println(" 31") ;
			pw.println(ze) ;				// z値(長軸の端点)
			pw.println("210") ;
			pw.println("0.0") ;
			pw.println("220") ;
			pw.println("0.0") ;
			pw.println("230") ;
			pw.println("1.0") ;
			pw.println(" 40") ;
			pw.println(ha) ;				// 短軸の比率
			pw.println(" 41") ;
			pw.println(kstat) ;				// 開始角度(ラジアン)
			pw.println(" 42") ;
			pw.println(kend) ;				// 終了角度(ラジアン)
	}

	// 文字列の判別
	public int ha_ascii(String str) {
				int mojh=1 ;				// 文字列に漢字ひらがな等がある
		if (str.matches("\\p{ASCII}*")) {
				mojh=0 ;					// 文字列はアスキー(1バイト)文字のみ
		}
			return mojh ;
	}
}
